<?php
require_once 'WebSearch.php';
require_once 'WebResult.php';
require_once 'WebResultSet.php';

/**
 * YahoǒNX
 */
class YahooSearch extends WebSearch
{
	/**
	 * YahoõLbVPrefix
	 */
	protected $cachePrefix = "yahoo";

	/**
	 * Yahoo!
	 */
	protected $name = "Yahoo!";
	
	/**
	 * Yahoo
	 */ 
	protected function searchCore($query, $offset, $count)
	{
		// WebAPIŌ
		$url ='http://api.search.yahoo.co.jp/WebSearchService/V1/webSearch?appid=YourID&format=any&language=ja';
		$url.='&query='.urlencode($query);
		$url.='&results='.$count;
		$url.='&start='.($offset + 1);

		// DOMDocument
		$xml = simplexml_load_file($url);
		
		return $xml;
	}

	/**
	 * LbVɕۑ
	 */
	protected function cacheData()
	{
		// jsonŕɕϊĂ
		$this->cache->save(json_encode($this->data), $this->cacheKey);
	}
	
	/**
	 * ʂ𐮌`ĕԂ
	 */
	protected function getResult($data)
	{
		$xml = NULL;
		if(is_string($data)) {
			// ̏ꍇ̓fR[h
			$xml = json_decode($data);
		}
		else {
			$xml = $data;
		}

		$webResultSet = new WebResultSet();
		
		if($xml->Result) {
			foreach($xml->Result as $nodelist) {
				$webResult = new WebResult($nodelist->Title, $nodelist->Url);
				$webResult->description = $nodelist->Summary;
				$webResult->cacheUrl = $nodelist->Cache->Url;
				
				array_push($webResultSet->result, $webResult);
			}
			
//		var_dump($data);
			$webResultSet->count = (int)$data{'totalResultsAvailable'};
		}

		return $webResultSet;
	}
}

?>
