<?php
require_once('MashupSearch.class.php');
require_once("search.common.php");

function search($query, $offset, $url = NULL)
{
	// クラス作成
	$searcher = new MashupSearch(array(MashupSearch::GOOGLE, MashupSearch::YAHOO, MashupSearch::LIVE));
	// 検索します
	$searcher->search($query, $offset);
	
	// xajaxのレスポンスクラス作成
	$objResponse = new xajaxResponse();

	// 検索結果取得
	$result = $searcher->getResult();

	$html = '<div class="result">' . "\n";
	$i = 0;
	$totalcount = 0;
	foreach ($result as $res) {
		$totalcount += $res->count;

		$match = "";
		if($url) {

			$num = $offset * 10 + 1;
			foreach($res->result as $r) {
				if(!(strpos($r->url, $url) === false)) {
					if($match != "") {
//						$match .= '&nbsp;|';
					}
					$match .= '&nbsp;<a href="#' . $res->getId() . $num . '">' . $num . '</a>';
				}
				$num++;
			}
		}
		
		if($offset == 0) {
			// 最初だけ
			$html .= '<div id="result' . $i . '">';
			$html .= '<h2>';
			$html .= $res->getName();
			$html .= "</h2>\n";
			
			if($url) {
				$html .= "<div id=\"match_" . $i . "\">". $match . "</div>\n";
			}
			
			$html .= "<ol id=\"". $res->getId() . "\">\n";	
			$html .= $searcher->makeResultHTML($res);
			$html .= "</ol>\n";
			$html .= "</div>\n";
			
			if($i == count($result) - 1) {
				$html .= "</div>\n";
				
				// 検索結果を表示する
				$objResponse->assign("result", "innerHTML", $html);
			}
		}
		else {
			// 後は、それぞれの検索結果に追記していく
			$objResponse->append($res->getId(), "innerHTML", $searcher->makeResultHTML($res));
			
			if($url) {
				$objResponse->append('match_' . $i , "innerHTML", $match);
			}
		}
		
		$i++;
	}

	if($offset == 4 || $totalcount == 0) {
		// 50件検索し終わったら、ボタンを使用可能にする
		$objResponse->assign("submit","value","検索");
		$objResponse->assign("submit","disabled",false);
	}
	else {
		// 続けて検索を行なう
		$offset++;
		
		$query = str_replace('"', '&quot;', $query);
		$script = 'xajax_search("' .$query.'", '.$offset;
		if($url) {
			$script .= ", '" . $url ."');";
		}
		else {
			$script .= ');';
		}
		$objResponse->script($script);
	}
	return $objResponse;
}

$xajax->processRequest();	
?>